; 
    include \masm32\include\masm32rt.inc
    .686
    include timers.asm

    isqrt       PROTO :DWORD
    isqrt_p4    PROTO :DWORD

    fisqrt      PROTO :DWORD
    fisqrt_not  PROTO :DWORD

; 
    .data
    .code
; 
start:
; 

    xor   ebx, ebx
    .WHILE ebx <= 100
      print ustr$(ebx),9
      invoke isqrt, ebx
      print ustr$(eax),9
      invoke fisqrt, ebx
      print ustr$(eax),13,10
      inc   ebx
    .ENDW
    print chr$(13,10)

    inkey "Press any key to continue...",13,10

    xor   ebx, ebx
    .WHILE ebx <= 100
      print ustr$(ebx),9
      invoke isqrt_p4, ebx
      print ustr$(eax),9
      invoke fisqrt_not, ebx
      print ustr$(eax),13,10
      inc   ebx
    .ENDW
    print chr$(13,10)

    inkey "Press any key to continue...",13,10

    LOOP_COUNT EQU 1000000

    print "isqrt     : "
    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      invoke isqrt, 999
    counter_end
    print ustr$(eax)," cycles",13,10

    print "isqrt_p4  : "
    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      invoke isqrt_p4, 999
    counter_end
    print ustr$(eax)," cycles",13,10

    print "fisqrt    : "
    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      invoke fisqrt, 999
    counter_end
    print ustr$(eax)," cycles",13,10

    print "fisqrt_not: "
    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      invoke fisqrt_not, 999
    counter_end
    print ustr$(eax)," cycles",13,10,13,10

    inkey "Press any key to exit..."
    exit

; 
; This is based on MSVC code by Norbert Juffa, from Paul Hsieh's
; Square Roots page:
;
;   http://www.azillionmonkeys.com/qed/sqroot.html#calcmeth
;
; 

iterasm MACRO n
    lea   edx, [eax+(1 SHL n)]
    lea   ebx, [eax+(2 SHL n)]
    shl   edx, n
    mov   esi, ecx
    sub   ecx, edx
    cmovnc eax, ebx
    cmovc ecx, esi
ENDM

iterasm_p4 MACRO n
    mov   edx, 1 SHL n
    mov   ebx, 2 SHL n
    or    edx, eax
    or    ebx, eax
    shl   edx, n
    sub   ecx, edx
    sbb   esi, esi
    sub   eax, ebx
    and   eax, esi
    add   eax, ebx
    and   edx, esi
    add   ecx, edx
ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

isqrt proc arg:DWORD
    mov   ecx, [esp+4]          ; arg
    push  ebx                   ; save as per calling convention 
    push  esi                   ; save as per calling convention 
    xor   eax, eax              ; 2*root
    ; iteration 15
    mov   ebx, 2 SHL 15
    mov   esi, ecx
    sub   ecx, 1 SHL 30
    cmovnc eax, ebx
    cmovc ecx, esi
    iterasm 14
    iterasm 13
    iterasm 12
    iterasm 11
    iterasm 10
    iterasm 9
    iterasm 8
    iterasm 7
    iterasm 6
    iterasm 5
    iterasm 4
    iterasm 3
    iterasm 2
    iterasm 1
    ; iteration 0
    mov   edx, 1
    mov   ebx, 2
    add   edx, eax
    add   ebx, eax
    sub   ecx, edx
    cmovnc eax, ebx
    shr   eax, 1
    mov   esi, [esp]            ; restore as per calling convention
    mov   ebx, [esp+4]          ; restore as per calling convention
    add   esp, 8                ; remove temp variables
    ret   4                     ; pop one DWORD arg and return
isqrt endp 

align 4

isqrt_p4 proc arg:DWORD
    mov   ecx, [esp+4]          ; arg
    push  ebx                   ; save as per calling convention 
    push  esi                   ; save as per calling convention 
    xor   eax, eax              ; 2*root
    ; iteration 15
    mov   ebx, 2 SHL 15
    mov   esi, ecx
    sub   ecx, 1 SHL 30
    cmovnc eax, ebx
    cmovc ecx, esi
    iterasm_p4 14
    iterasm_p4 13
    iterasm_p4 12
    iterasm_p4 11
    iterasm_p4 10
    iterasm_p4 9
    iterasm_p4 8
    iterasm_p4 7
    iterasm_p4 6
    iterasm_p4 5
    iterasm_p4 4
    iterasm_p4 3
    iterasm_p4 2
    iterasm_p4 1
    ; iteration 0
    mov   edx, 1
    mov   ebx, 2
    add   edx, eax
    add   ebx, eax
    sub   ecx, edx
    cmovnc eax, ebx
    shr   eax, 1
    mov   esi, [esp]            ; restore as per calling convention
    mov   ebx, [esp+4]          ; restore as per calling convention
    add   esp, 8                ; remove temp variables
    ret   4                     ; pop one DWORD arg and return
isqrt_p4 endp
 
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

GLOBAL oldcw dw 0
GLOBAL newcw dw 0

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

fisqrt proc arg:DWORD
    fstcw oldcw
    fwait
    mov   ax, oldcw
    or    ax, 0C00h             ; Set RC field for truncating mode
    mov   newcw, ax
    fldcw newcw

    fild  DWORD PTR[esp+4]
    fsqrt
    push  eax
    fistp DWORD PTR[esp]
    pop   eax  

    fldcw oldcw
    ret   4
fisqrt endp

align 4

fisqrt_not proc arg:DWORD
    fild  DWORD PTR[esp+4]
    fsqrt
    push  eax
    fistp DWORD PTR[esp]
    pop   eax
    ret   4
fisqrt_not endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

end start
